dnl Copyright (c) Istituto Nazionale di Fisica Nucleare (INFN). 2006-2010.
dnl
dnl Licensed under the Apache License, Version 2.0 (the "License");
dnl you may not use this file except in compliance with the License.
dnl You may obtain a copy of the License at
dnl
dnl     http://www.apache.org/licenses/LICENSE-2.0
dnl
dnl Unless required by applicable law or agreed to in writing, software
dnl distributed under the License is distributed on an "AS IS" BASIS,
dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
dnl See the License for the specific language governing permissions and
dnl limitations under the License.

dnl Usage:
dnl - VOMS_LIBS

AC_DEFUN([AC_VOMS],
[

  AC_ARG_WITH(
    voms-prefix,
    AC_HELP_STRING(
      [--with-voms-prefix=DIR],
      [root of the voms installation]
    ),
    [ac_voms_prefix=$withval],
    [ac_voms_prefix=${VOMS_LOCATION:-/usr}]
  )

  AC_ARG_WITH(
    voms-include,
    AC_HELP_STRING(
      [--with-voms-include=DIR],
      [root of the boost installation]
    ),
    [ac_voms_include=$withval],
    [ac_voms_include=${VOMS_INCLUDE_LOCATION:-/usr/include}]
  )

  if test "x$host_cpu" = "xx86_64"; then
     library_path="lib64"
  else
     library_path="lib"
  fi

  AC_MSG_CHECKING([for VOMS installation at ${ac_voms_prefix}])

  if test -n "$ac_voms_include" ; then
     VOMS_CFLAGS="-I$ac_voms_include"
     VOMS_PATH_LIBS="-L$ac_voms_prefix/$library_path"
  else
     VOMS_CFLAGS=""
     VOMS_PATH_LIBS=""
  fi

  VOMS_LIBS="-lvomsapi"
  VOMS_INSTALL_PATH=$ac_voms_prefix
  VOMS_INCLUDE_PATH=$ac_voms_include

#if not needed by client and gridftp remove this variables
  AC_SUBST(VOMS_INSTALL_PATH)
  AC_SUBST(VOMS_INCLUDE_PATH)
#down to here  
  AC_SUBST(VOMS_CFLAGS)
  AC_SUBST(VOMS_PATH_LIBS)
  AC_SUBST(VOMS_LIBS)
])

